unit FrmWeekBlockIODlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, TimePeriod;

type
TFrmWeekBlockIODialog = class(TForm)
   Bevel1: TBevel;
   Label1: TLabel;
   Label2: TLabel;
   EditStart: TEdit;
   EditEnd: TEdit;
   Label3: TLabel;
   EditString: TEdit;
   CancelBtn: TButton;
   OkBtn: TButton;
    procedure OkBtnClick(Sender: TObject);
private
   m_TPeriod: TTimePeriod;

   function  Init(aPeriod: TTimePeriod): Boolean;
   procedure Deinit;

   function  GetData: Boolean;
   procedure CheckTime(aEdit: TEdit);
   function  GetTime(aEdit:TEdit): TDateTime;
public
   function Execute(aTimePeriod: TTimePeriod):Boolean;
end;
{**************************************************************************************************}
var
  FrmWeekBlockIODialog: TFrmWeekBlockIODialog;

implementation
Uses utils;

{$R *.DFM}
{**************************************************************************************************}
{* My own functions                                                                               *}
{**************************************************************************************************}
function  TFrmWeekBlockIODialog.Execute(aTimePeriod: TTimePeriod):Boolean;
begin
   Result := FALSE;
   if(Init(aTimePeriod)) then
      Result := (ShowModal = mrOk);
   Deinit;
end;
{**************************************************************************************************}
function  TFrmWeekBlockIODialog.Init(aPeriod: TTimePeriod): Boolean;
begin
   try
      Result := Assigned(aPeriod);
      if(Result) then begin
         m_TPeriod := aPeriod;
         EditStart.Text  := TimeToStr(m_TPeriod.StartDate);
         EditEnd.Text    := TimeToStr(m_TPeriod.EndDate  );
         EditString.Text := m_TPeriod.DisplayString;
      end;

   except
      on E:Exception do begin
         Result := FALSE;
         MessageDlg('Error while initilizing the dialog.'+#13+#10+E.Message, mtError, [mbOk] ,0);
      end;
   end;
end;
{**************************************************************************************************}
procedure TFrmWeekBlockIODialog.Deinit;
begin
   m_TPeriod := NIL;
end;
{**************************************************************************************************}
function  TFrmWeekBlockIODialog.GetData: Boolean;
begin
   try
      CheckTime(EditStart);
      CheckTime(EditEnd  );
      m_TPeriod.StartDate := GetTime(EditStart);
      m_TPeriod.EndDate   := GetTime(EditEnd);
      m_TPeriod.DisplayString := EditString.Text;
      Result := TRUE;
   except
      on E:Exception do begin
         Result := FALSE;
         MessageDlg('Error while getting data from fields.'+#13+#10+E.Message, mtError, [mbOk] ,0);
      end;
   end;
end;
{**************************************************************************************************}
procedure TFrmWeekBlockIODialog.CheckTime(aEdit: TEdit);
begin
   try
      StrToTime(aEdit.Text);
   except
      aEdit.SetFocus;
      Raise;
   end;
end;
{**************************************************************************************************}
function  TFrmWeekBlockIODialog.GetTime(aEdit:TEdit): TDateTime;
begin
   Result := GetTimePart(StrToTime(aEdit.Text));
end;
{**************************************************************************************************}
{**************************************************************************************************}
{* My own functions (END)                                                                         *}
{**************************************************************************************************}
procedure TFrmWeekBlockIODialog.OkBtnClick(Sender: TObject);
begin
   ModalResult := mrNone;
   if(GetData) then
      ModalResult := mrOk;
end;
{**************************************************************************************************}
end.
 